/*
 * DRtalk.java
 *
 * Created on 17. august 2009, 13:57
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package webreader;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.net.MalformedURLException;
import java.net.Socket;
import java.net.URL;
import java.net.URLConnection;
import java.net.UnknownHostException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.LinkedList;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.regex.Pattern;
import java.util.regex.Matcher;
import org.json.JSONArray;
import org.json.JSONException;



/**
 *
 * @author Rune
 */
public class DRtalk {

    /** Creates a new instance of DRtalk */
    public DRtalk() {
    }
    static String GetURLString (String urlstr) {
        System.setProperty("java.net.useSystemProxies", "true");
        try {
            String line = "";
            urlstr = "http://"+urlstr;
            
            URLConnection yc = new URL(urlstr).openConnection();
            yc.setConnectTimeout(100);
            yc.setReadTimeout(2000);
            BufferedReader in;
            for (int gange = 1; gange < 3; gange++) {  // looper for at sætte connection timeout op ved fejl
                try {
                    in = new BufferedReader(new InputStreamReader(yc.getInputStream(), "UTF-8"));
                    line = in.readLine();
                    while (in.ready()) {
                        line = line+":"+in.readLine();
                    }
                    in.close();
                    return line;
                } catch (MalformedURLException ex) {
                    line = ex.getMessage();
                    System.out.println("URL exception: "+line);
                }
                int t = yc.getReadTimeout() * 2;
                yc.setReadTimeout(t);
                System.out.println(t);
            }
            return line;
        } catch (IOException ex) {
            return ex.getMessage();
        }
    }
    
    public void fillScheduleList(LinkedList<tvInfo> tvInfoList, String broadcastDate, String channel_source_url){
        this.parseSchedule(tvInfoList, this.getSchedule(channel_source_url, broadcastDate), broadcastDate, channel_source_url);
    }
    
    public String convertTimestamp(String UTCtime) {
        UTCtime = UTCtime.substring(6,UTCtime.length()-2);
        Calendar cal = Calendar.getInstance();
        cal.setTimeInMillis(Long.valueOf(UTCtime));
        //                                           20090613123456         
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        return sdf.format(cal.getTime());
    }

    private static String txtToHtml(String s) {
            StringBuilder builder = new StringBuilder();
            boolean previousWasASpace = false;
            for (char c : s.toCharArray()) {
                if (c == ' ') {
                    if (previousWasASpace) {
                        builder.append("&nbsp;");
                        previousWasASpace = false;
                        continue;
                    }
                    previousWasASpace = true;
                } else {
                    previousWasASpace = false;
                }
                switch (c) {
                    case '<':
                        builder.append("&lt;");
                        break;
                    case '>':
                        builder.append("&gt;");
                        break;
                    case '&':
                        builder.append("&amp;");
                        break;
                    case '"':
                        builder.append("&quot;");
                        break;
                    case '\n':
                        builder.append(" ");
                        break;
                    // We need Tab support here, because we print StackTraces as HTML
                    case '\t':
                        builder.append("&nbsp; &nbsp; &nbsp;");
                        break;
                    default:
                        builder.append(c);

                }
            }
/*            String converted = builder.toString();
            String str = "(?i)\\b((?:https?://|www\\d{0,3}[.]|[a-z0-9.\\-]+[.][a-z]{2,4}/)(?:[^\\s()<>]+|\\(([^\\s()<>]+|(\\([^\\s()<>]+\\)))*\\))+(?:\\(([^\\s()<>]+|(\\([^\\s()<>]+\\)))*\\)|[^\\s`!()\\[\\]{};:\'\".,<>?«»“”‘’]))";
            Pattern patt = Pattern.compile(str);
            Matcher matcher = patt.matcher(converted);
            converted = matcher.replaceAll("<a href=\"$1\">$1</a>");
            */
            return builder.toString();
        }    
    
    public boolean parseSchedule(LinkedList<tvInfo> tvInfoList, String scheduleString, String date, String channelID){
        if(scheduleString==null)
            return true;

        org.json.JSONArray scheduleData;
        org.json.JSONArray timeSections;
        
        try{
            timeSections  =  new org.json.JSONObject(scheduleString).getJSONArray("TimeSection");
            for (int xts = 0; xts < timeSections.length(); xts++) {
                org.json.JSONObject timeSection = timeSections.getJSONObject(xts);
            //Get the result which are the data
                scheduleData =  timeSection.getJSONArray("Programs");
                org.json.JSONObject schedule = null;
                for (int i=0; i  < scheduleData.length();i++){
                    try{
                        schedule = scheduleData.getJSONObject(i);

                        String titel = schedule.optString("Title","");
                        if(!titel.isEmpty()){
                            tvInfo tvInfoData = new tvInfo();
                            tvInfoData.Program = titel;
                            tvInfoData.ProgramInfo = schedule.optString("Punchline", null);
                            tvInfoData.ProgramInfoExt = "Originaltitel: " +schedule.optString("OriginalTitle", "");
                            //Read program rating

                            //Url for specific program or show in general
                            tvInfoData.PromoUrl = schedule.optString("ImdbUrl", null);

                            if (schedule.optBoolean("HasDescription", false)) {
                                String DRid = schedule.optString("Id", null);
                                if (DRid != null) {
                                    tvInfoData.ProgramInfoExt = getDescription(DRid,date,channelID) + ". " + tvInfoData.ProgramInfoExt;
                                }
                            }

                            //Read program_start
                            String DRtime = schedule.optString("StartDateTime",null);
                            if (DRtime == null) continue;
                            String xmltime = convertTimestamp(DRtime);
                            tvInfoData.StartTime = xmltime;
                            //Read stop
                            tvInfoData.StopTime = convertTimestamp(schedule.optString("EndDateTime",null));

                            //Read ppu_isrerun
                            tvInfoData.repeat = schedule.optBoolean("IsRerun", false);

                            //Read episode number
                            int episodeIndexStart = tvInfoData.Program.indexOf('(');
                            int episodeIndexEnd = tvInfoData.Program.indexOf(')', episodeIndexStart);
                            String episode = null;
                            String episodeNo = null;
                            String episodeMax = null;
                            if( (episodeIndexStart>0) && (episodeIndexEnd>episodeIndexStart) )
                            {
                                //System.out.println(ppu_title);
                                //System.out.println(EpisodeIndexStart + " " + EpisodeIndexEnd + " : " );
                                episode = tvInfoData.Program.substring(episodeIndexStart+1, episodeIndexEnd);
                                int episodeIndexColon = episode.indexOf(':');//Find out if there are a max series number too.
                                if(episodeIndexColon!=-1){
                                    episodeNo = episode.substring(0, episodeIndexColon);
                                    episodeMax = episode.substring(episodeIndexColon+1);
                                }
                                else{
                                    episodeNo = episode;
                                }

                                try{
                                    //Build episode number based on xmltv_ns: http://xml.coverpages.org/XMLTV-DTD-20021210.html
                                    tvInfoData.EpisodeNo = Integer.parseInt(episodeNo);//-1; //see if it is a number

                                    if(episodeMax!=null)
                                        tvInfoData.EpisodeMax = Integer.parseInt(episodeMax);//-1;//see if it is a number

                                    episode = episodeNo;
                                    //Remove episode number from title
                                    tvInfoData.Program = tvInfoData.Program.substring(0, episodeIndexStart).trim();
                                }catch( NumberFormatException ex){
                                    episode = null;
                                    //System.out.println("Episode Exception: eNo:" + episodeNo + " mNo:" + episodeMax);
                                }
                            }


                            //if no episode number is present in the title, read the episode tag
                            if(episode==null){
                                if (schedule.has("prd_episode_number")){
                                    tvInfoData.EpisodeNo = schedule.getInt("prd_episode_number");
                                    if (schedule.has("prd_episode_total_number"))
                                        tvInfoData.EpisodeMax = schedule.getInt("prd_episode_total_number");
                                }
                            }

                            if(tvInfoData.Program!=null){
                                tvInfoData.Program = txtToHtml(tvInfoData.Program);
                            }
                            if(tvInfoData.ProgramInfo!=null){
                                tvInfoData.ProgramInfo = txtToHtml(tvInfoData.ProgramInfo);
                            }
                            if(tvInfoData.ProgramInfoExt!=null){
                                tvInfoData.ProgramInfoExt = txtToHtml(tvInfoData.ProgramInfoExt);
                            }

                            if(false){
                                System.out.println(tvInfoData.StartTime);
                                System.out.println(tvInfoData.StopTime);
                                System.out.println(tvInfoData.Program);
                                System.out.println(tvInfoData.ProgramInfo);
                                System.out.println(tvInfoData.ProgramInfoExt);
                                System.out.println("Rerun:" + tvInfoData.repeat);
                                System.out.println("Episode:" + episode + "   - " + episodeNo);
                            }

                            if(Long.parseLong(tvInfoData.StopTime)>=Long.parseLong(tvInfoData.StartTime)){
                                tvInfoData.Channel = channelID;
//                                tvInfoData.Credits = myCredits;
                                tvInfoList.add(tvInfoData);
                            }
                            else {
                                System.out.println("Error parsing schedule stop before start\n" +
                                        "Start: " + tvInfoData.StartTime + "\n" +
                                        "Stop:  " + tvInfoData.StopTime + "\n" +
                                        "Program: " + tvInfoData.Program + " chan: " + tvInfoData.Name);
                                return false;
                            }
                        }
                    } catch (Exception ex){
                        System.out.println("Error parsing schedule string 1:" + schedule.toString());
                        System.out.println(ex.getMessage());
                        return false;
                     }
                }
            }
        } catch (Exception ex){
            System.out.println("Error parsing schedule string 2:" + scheduleString); //TODO
            System.out.println(ex.getMessage());
            return false;
        }
        return true;
    }
    
    /** Returns a list of broadcast dates that are >= current broadcast date */
    public LinkedList<String> getUsefulBroadcastDates(){
        LinkedList<String> ll = this.getParsedAvailableBroadcastDates();
        String currentBroadcastData = this.getParsedCurrentBroadcastDate();
        while(true){
            if(ll.getFirst().equals(currentBroadcastData))
                break;
            else
                ll.removeFirst();
        }
        return ll;
    }
    private void DoCredits(String creditsTag, String names, credits creditsData){
        names = names.trim().replace(".", "");
        String[] nameList = names.split("og|,");
        if(creditsTag.equalsIgnoreCase("Medvirkende:")){
            for(String name : nameList){
                if(name.contains(":")){
                    int colonIndex = name.indexOf(":");

                    actor actorData = new actor();
                    actorData.role = name.substring(0, colonIndex).trim().replace("\"", "&quot;");
                    actorData.actorName = name.substring(colonIndex+1).trim();
                    creditsData.Actor.add(actorData);
                }
                else
                    creditsData.Actor.add(new actor(name.trim()));
            }
        }
        else if(creditsTag.equalsIgnoreCase("Instruktion:") | creditsTag.equalsIgnoreCase("Instrukt�r:")){
            for(String name : nameList){
               creditsData.Director.add(name.trim());
            }
            
        }
            
            
    }
    
    /** Returns a linked list of available broadcast dates */
    public LinkedList<String> getParsedAvailableBroadcastDates(){
        String availableBroadcastDates = this.getAvailableBroadcastDates();
        
        LinkedList<String> ll = new LinkedList<String>();
        if(availableBroadcastDates.indexOf("\"error\"")!=-1)
            return null;
        
        int resultIndex = availableBroadcastDates.indexOf("\"result\"");
        int dataIndex = availableBroadcastDates.indexOf("[", resultIndex);
        //System.out.println("res:" + resultIndex + " dat:" + dataIndex);
        if((resultIndex==-1) || (dataIndex==-1))
            return null;
        
        int startIndex = 0;// = availableBroadcastDates.indexOf("\"", dataIndex);
        int endIndex = dataIndex;//availableBroadcastDates.length();
                
        while(true)
        {
            startIndex = availableBroadcastDates.indexOf("\"", endIndex+1);
            endIndex = availableBroadcastDates.indexOf("\"", startIndex+1);
            //System.out.println("start:" + startIndex + " end:" + endIndex);
            if((startIndex==-1) || (endIndex==-1))
                break;
            String availableBroadcastDate = new String();
            availableBroadcastDate = availableBroadcastDates.substring(startIndex+1, endIndex);
            //System.out.println(availableBroadcastDate);
            ll.add(availableBroadcastDate);
        }                    
        return ll;
    }
    
    /** <b>Returns a list of channels.</b><br>
     * Type is either tv or radio.
     */
    public String getChannels(String type){
        String str = null;
            str = this.query("channels?", "\"type\":" + type);
        return str;
    }
    
    public LinkedList<channelData> getParsedChannels(String type){
        String channels = this.getChannels(type);
        String name;
        String source_url, id;
        LinkedList<channelData> ll = new LinkedList<channelData>();
        
        org.json.JSONArray webJSONData;
        try {
            //Get the result which are the data
            webJSONData = new org.json.JSONObject(channels).getJSONArray("Channels");
       
            org.json.JSONObject schedule = null;
            for (int i=0; i  < webJSONData.length();i++){
                org.json.JSONObject channel = webJSONData.getJSONObject(i);

                name = channel.optString("Name", null);
                source_url = channel.optString("SourceUrl", null);
                id = channel.optString("Id", null);
                if( (name!=null) && (source_url!=null) && (id!=null)){
                    channelData cd = new channelData();
//                    cd.icon = source_url.substring(source_url.lastIndexOf('/')+1);
                    cd.name = name;
                    cd.source = source_url;
                    cd.id = id;
                    ll.add(cd);
                    //System.out.println(source_url);
                }
            }
        } catch (JSONException ex) {
            Logger.getLogger(DRtalk.class.getName()).log(Level.SEVERE, null, ex);
        }
        return ll;
    }

    public void printChannels(){
        String channels = this.getChannels("tv");
        if(channels.indexOf("\"error\"")!=-1)
            return;
        
        int resultIndex = channels.indexOf("\"result\"");
        if(resultIndex==-1)
            return;
        
        int startSrcIndex = 0;
        int endSrcIndex = resultIndex;
        int startNameIndex = 0;
        int endNameIndex = resultIndex;
        
        while(true){
            startNameIndex = channels.indexOf("\"name\":", endSrcIndex);
            endNameIndex = channels.indexOf("\"", startNameIndex+8);
            
            startSrcIndex = channels.indexOf("\"source_url\":", endSrcIndex);
            endSrcIndex = channels.indexOf("\"", startSrcIndex+14);
            if((startSrcIndex==-1)||(endSrcIndex==-1))
                break;
            else{
                String source_url = channels.substring(startSrcIndex+14, endSrcIndex);
                String channelName = channels.substring(startNameIndex+8, endNameIndex);
//                String gif = source_url.substring(source_url.length()-3);
//                System.out.println("<channel id = \"" + source_url + "\">\n" +
//                        "  <display-name>"+ channelName + "</display-name>\n" +
//                        "  <id>"+id+ "</id>\n" +
//                        "</channel>");
            }
        }
        return;
    }
    
    /** Returns a list of programs.*/
    public String getSchedule(String channel_source_url, String broadcastDate){
//        "schedule?startTimesectionId=1&days=" + $date + "&channelid=" + $chan->{'_dr_listing_id'} + "&oneTimesectionOnly=false&mediaType=tv";        
        
        String str = null;
        String url = "schedule?startTimesectionId=1&days=DAGE&channelid=KANALID&oneTimesectionOnly=false&mediaType=tv";
        url = url.replace("DAGE", broadcastDate);
        url = url.replace("KANALID", channel_source_url);
            str = this.query(url, "");
        return str;
    }
    /** Returns a description from DR.*/
    public String getDescription(String DRid, String broadcastDate, String channel_source_url){
        
        String str = null;
        String url = "ProgramDetails/?id=DRid&days=DAGE&channelid=KANALID&mediatype=tv";
        url = url.replace("DRid", DRid);
        url = url.replace("DAGE", broadcastDate);
        url = url.replace("KANALID", channel_source_url);
            str = this.query(url, "");
        if (str != null) {
            try {
                str = new org.json.JSONObject(str).optString("Description", null);
            } catch (JSONException ex) {
                Logger.getLogger(DRtalk.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        return str;
    }
    
    /** Returns a string of available broadcast dates.*/
    public String getAvailableBroadcastDates(){
        String str = null;
            str = this.query("availableBroadcastDates", "");
        return str;        
    }
    
    /** Returns a string with current broadcast date.*/
    public String getCurrentBroadcastDate(){
        String str = null;
        str = this.query("currentBroadcastDate", "");
        return str;        
    }
    
    /** Return a parsed currentBroadcastDate */
    public String getParsedCurrentBroadcastDate(){
        String currentBroadcastDate = this.getCurrentBroadcastDate();
        if(currentBroadcastDate.indexOf("\"error\"")!=-1)
            return null;
        
        int resultIndex = currentBroadcastDate.indexOf("\"result\"");
        if(resultIndex==-1)
            return null;
        
        int startIndex = currentBroadcastDate.indexOf("\"", resultIndex+8);
        int endIndex = currentBroadcastDate.indexOf("\"", startIndex+1);
        if((startIndex==-1)||(endIndex==-1))
            return null;
        
        String parsedCurrentBroadcastDate = currentBroadcastDate.substring(startIndex+1, endIndex);
        //System.out.println("start:" + startIndex + " end:" + endIndex);
        //System.out.println(parsedCurrentBroadcastDate);
        
        return parsedCurrentBroadcastDate;
    }
    
    /** Function talking to beta.dr.dk through JSON-RPC
     *
     */
    
    
    public String query(String method, String params){
        String r;
        r = queryURL(method,params);
        return r;
    }
    
    public String queryURL(String method, String params){
           String host = "www.dr.dk";
           String file = "/tv/oversigt/json/guide/"+method+params;
           String r;
           r = GetURLString(host+file);
           return r;
    }

    //Work in progress - currently unused!!!!!
    //{"id":5,"result":[{"pro_title":"I hovedet p� unger","pro_category":"Dramatik og fiktion","pro_targetgroup":"SM� B�RN (3-7)","pro_intention":"AT GIVE OPLEVELSE(R)",
    public String createList(String data, JSON parent){
        while(true){
            //System.out.println(data);
            //int curlyIndexStart = data.indexOf('{', colonIndex);
            int curlyIndexEnd = data.indexOf('}');
            int quoteIndexStart = data.indexOf('"');
            int quoteIndexEnd = data.indexOf('"', quoteIndexStart+1);
            //Find first colon that is NOT between quotes.
            int colonIndex = -1;
            do{
                colonIndex = data.indexOf(':', colonIndex+1);
                if(colonIndex==-1)
                    break;
                if(colonIndex>curlyIndexEnd){
                    colonIndex=-1;
                    break;
                }
                if((colonIndex<quoteIndexStart) || (colonIndex>quoteIndexEnd)){
                    break;
                }
            }while(true);

            //Find first comma that is NOT between quotes.
            int commaIndex = -1;
            do{
                commaIndex = data.indexOf(',', commaIndex+1);
                if(commaIndex==-1)
                    break;
                if(commaIndex>curlyIndexEnd){
                    commaIndex = -1;
                    break;
                }
                if((commaIndex<quoteIndexStart) || (commaIndex>quoteIndexEnd)){
                    break;
                }
            }while(true);


            //System.out.println("s:" + idIndexStart + " e:" + idIndexEnd + " colon:" + colonIndex);
            //System.out.println("{ s:" + curlyIndexStart + " e:" + curlyIndexEnd + " comma:" + commaIndex);

            //Search for colon or comma and ignore paranthesis
            //System.out.println(parent.name);

            if((colonIndex==-1) && (commaIndex)==-1){
                String name = data;//.substring(0, commaIndex);
                data.substring(commaIndex+1);
                System.out.println("  Last Data:" + name);
                JSON child = new JSON(name);
                parent.list.add(child);
                if(curlyIndexEnd==-1)
                    return null;
                else
                    return data.substring(curlyIndexEnd+1);

            }
            //This happens when the first thing is an ID
            else if( ((colonIndex<commaIndex) && (colonIndex != -1)) || ((colonIndex!=-1) && (commaIndex==-1)) ){
                String name = data.substring(0, colonIndex);
                System.out.println("ID:" + name);
                JSON child = new JSON(name);
                child.list = new LinkedList<JSON>();
                parent.list.add(child);
                //Create a sub element
                data = createList(data.substring(colonIndex+1), child);
                if(data==null)
                    return null;

            }
            else if((colonIndex>commaIndex)){
                if(commaIndex==-1)
                    System.out.println("ERRORLINE:" + data);
                String name = data.substring(0, commaIndex);
                System.out.println("  Data:" + name);
                JSON child = new JSON(name);
                parent.list.add(child);
                data = data.substring(commaIndex+1);
            }
        }
       
    }
   
}
